Index: PROJECT_CORE_MPI/CORE_MPI/BRANCHES/v0.01/PE.vhd
===================================================================
--- PROJECT_CORE_MPI/CORE_MPI/BRANCHES/v0.01/PE.vhd	(revision 37)
+++ PROJECT_CORE_MPI/CORE_MPI/BRANCHES/v0.01/PE.vhd	(revision 39)
@@ -21,4 +21,5 @@
 use IEEE.STD_LOGIC_1164.ALL;
 library NocLib ;
+library Std;
 --use IEEE.STD_LOGIC_ARITH.ALL;
 --use IEEE.STD_LOGIC_UNSIGNED.ALL;
@@ -26,4 +27,5 @@
 use work.Packet_type.all;
 use work.MPI_RMA.all;
+use std.textio.all;
 use IEEE.NUMERIC_STD.ALL;
 
@@ -81,6 +83,5 @@
 	signal Lib_Init : std_logic; -- l'initialisation est terminée 
  --signaux pour la gestion de la MAE
- type typ_mae is (start,Fillmem,NextFill,InitApp,InitCompleted,GetRank1,GetRank2,GetRank3,writeptr,InstrCopy, 
- putdata,putdata2,putcompleted,getdata,getdata2,getcompleted,terminate,st_timeout);
+ type typ_mae is (start,Fillmem,NextFill,InitApp,GetRank,WInCreate, putdata,getdata,WinCompleted,finalize,st_timeout);
 signal dcount : natural range 0 to 255:=0; --permet de compter le packet de données envoyées
 signal count,count_i : natural range 0 to 15:=0;
@@ -182,7 +183,18 @@
 	variable timeout,ct,dlen : natural range 0 to 255;
 	variable adrToset,SrcAdr,DestAdr : std_logic_vector(ADRLEN-1 downto 0);
+	variable mywin : Mpi_win;
 	variable iack : std_logic:='0';
 	variable  adresse,adresse_rd :natural range 0 to 65536;
 	variable status_reg,config_reg :std_logic_vector(Word-1 downto 0):=(others=>'0');
+	--=======================================================
+	--variables pour la création du fichier de résultats
+		type char_file is file of character;
+        file f: text;
+        variable status :file_open_status ;
+        variable char_count: integer range 0 to 65536 := 0;
+		  variable str: string (1 to 79) ;
+		  variable L: line; 
+		  variable fopened: std_logic:='0';
+--======================================================
 	begin
 	--=== Partie combinatoire du process ===================================
@@ -193,5 +205,10 @@
 			Libr.RamSel<=RamSel;
 			sram.data_out<=PE_ram_do;
-	--=== Fin de la partie combinatoire du process ==========================		
+	--=== Fin de la partie combinatoire du process ==========================	
+		
+		    
+           
+        --end loop;
+        
 	if (clk'event and clk='1') then 
 		if reset='1' then
@@ -220,4 +237,15 @@
 				timeout:=0;
 				dcount<=0;
+			if fopened='0' then 
+			file_open(status,f, integer'image(destid) & "test_file0.txt", APPEND_MODE);
+        --while not endfile(c_file_handle) loop
+			--end if;
+		
+				--write (l,string'("Ce fichier contient des resultats de la simulation ; ;" & " started at time ; " & time'image(now)));
+				--report l.all;
+           -- writeline (f, l) ;
+				fopened:='1';
+			end if;
+			 
 			 when Fillmem =>
 				if Ramsel='0' then 
@@ -256,5 +284,11 @@
 		when InitApp =>
 				--code pour Init 
-								
+				dlen:=1;
+				if ct=0 then
+				write (l,string'("Dlen; ;INIT of Process n°; " & image(MyRank) & "; started at ; " & time'image(now)));
+				
+				report l.all;
+            writeline (f, l) ;
+				end if;
 				pMPI_Init(ct,Libr,Clk,SRam);
 				PE_Instr_EN<=Libr.instr_en;
@@ -265,38 +299,40 @@
 				--if Libr.InitOk='1' then 
 				if ct=0 then 
-					RunState<=GetRank1;
+					RunState<=GetRank;
+					write (l,string'("Dlen; ;INIT;" & ";  ended at  ; " & time'image(now)));
+					report l.all;
+					writeline (f, l) ;  
 				end if;
 				
 		
-		when writeptr =>
-				
-		When InstrCopy =>
-				
-		
-		when InitCompleted =>
-				
-		when GetRank1 =>
-		
+		
+		when GetRank =>
+		if ct=0 then
+				
+				write (l,string'("Dlen; ; Rank ; " & "; started  ; " & time'image(now)));
+				report l.all;
+            writeline (f, l) ;  
+			end if;
 			pMPI_Comm_rank(ct,Libr,sram,MPI_COMM_WORLD,MyRank);
+			adresse_rd:=to_integer(unsigned(sram.addr_rd));
 			if ct=0 then
-				RunState<=PutData2;
+				RunState<=PutData;
+				write (l,string'("Dlen; ; Rank ; " & "; ended at  ; " & time'image(now)));
+				report l.all;
+            writeline (f, l) ;  
 			end if;
-			adresse_rd:=to_integer(unsigned(sram.addr_rd));
-
-		when GetRank2 =>
-			adresse_rd:=CORE_INIT_ADR+1;
-			if ramsel='0' then
-				RunState<=Getrank3;
-			end if;	
-		when GetRank3=>
-			adresse_rd:=CORE_INIT_ADR+1;
-			if ramsel='0' then
-				RunState<=putdata2;
-			end if;	
+			
+
+		when Wincreate =>
+			
+		
 		when putdata => --construire le packet pour le Put
 				
-				
-		when putdata2 =>
-					
+					--dlen:=251; ---
+					if ct=0 then
+					write (l,string'("Dlen;" & integer'image(dlen) & ";Put of Pr n°; " & image(MyRank) & "; started at ; " & time'image(now)));
+					report l.all;
+					writeline (f, l) ; 
+					end if;
 					if unsigned(MyRank) = 0 then 
 						Destrank:=1;
@@ -304,9 +340,9 @@
 						DestRank:=0;
 					end if;
-					dlen:=200; --- to_integer(unsigned(datalen));
+					 
 					SrcAdr:=std_logic_vector(to_unsigned(DATAPTR,ADRLEN));
 					DestAdr:=X"2000";
 					
-					pMPI_put(ct,Libr,Clk,Sram,SrcAdr,Dlen,MPI_int,destrank,DestAdr1 & DestAdr,Dlen,Mpi_int,Default_win);
+					pMPI_put(ct,Libr,Clk,Sram,SrcAdr,Dlen,MPI_int,destrank,DestAdr,Dlen,Mpi_int,Default_win);
 					adresse:=to_integer(unsigned(sram.addr_wr));
 					adresse_rd:=to_integer(unsigned(sram.addr_rd));
@@ -317,16 +353,23 @@
 					if ct=0 then
 						RunState<=GetData;
+					report "Put of Process n°; " & image(MyRank) & "; ended at ; " & time'image(now);
+					write (l,string'("Dlen;" & integer'image(dlen) & ";Put of Pr n°; " & image(MyRank) & "; ended at time ; " & time'image(now)));
+					report l.all;
+					writeline (f, l) ;  																	
 					end if;
-						
-			
-			when putcompleted =>
+					
 				
 			when getdata =>   --positionnement du mot de longueur des données
-			   
-					dlen:=200; --- to_integer(unsigned(datalen));
+					--dlen:=251; --- 
+					if ct=0 then
+					write (l,string'("Dlen;" & integer'image(dlen) & ";GET of Process n°; " & image(MyRank) & "; started at ; " & time'image(now)));
+					report l.all;
+					writeline (f, l) ; 
+					end if;
+					
 					SrcAdr:=X"0120";
 					DestAdr:=X"4000";
 					
-					pMPI_GET(ct,Libr,Clk,Sram,SrcAdr,Dlen,MPI_int,destrank,DestAdr1 & DestAdr,Dlen,Mpi_int,Default_win);
+					pMPI_GET(ct,Libr,Clk,Sram,SrcAdr,Dlen,MPI_int,destrank,DestAdr,Dlen,Mpi_int,Default_win);
 					adresse:=to_integer(unsigned(sram.addr_wr));
 					adresse_rd:=to_integer(unsigned(sram.addr_rd));
@@ -336,20 +379,46 @@
 					
 					if ct=0 then
-						RunState<=terminate;
+						RunState<=wincompleted;
+						assert ct/=0 report "GET_END " & integer'image(destrank)
+								severity Warning ;
+						write (l,string'("Dlen ;" & integer'image(dlen) & ";GET of Proc n°; " & image(MyRank) & "; ended at ; " & time'image(now)));
+					report l.all;
+					
+					writeline (f, l) ;  
 					end if;
-				when getdata2 =>
-					
-					
-				
-					
-				when getcompleted =>
-				
-					
+				
+				when WinCompleted =>
+				if ct=0 then
+						write (l,string'("Dlen ;" & integer'image(dlen) & ";Wait of Proc n°; " & image(MyRank) & "; started at ; " & time'image(now)));
+						report l.all;
+						writeline (f, l) ; 
+					end if;	
+					 pMPI_Win_wait(ct,Libr,sram,MyWin );
+					 adresse:=to_integer(unsigned(sram.addr_wr));
+					adresse_rd:=to_integer(unsigned(sram.addr_rd));
+					if ct=0 then
+						RunState<=finalize;	
+						write (l,string'("Dlen ;" & integer'image(dlen) & ";Wait of Proc n°; " & image(MyRank) & "; ended at ; " & time'image(now)));
+						report l.all;
+						writeline (f, l) ;
 						
-			when terminate =>
-			
-		
-					RunState<=start;
-					
+					end if;	  
+					
+						
+			when finalize =>
+					if ct=0 then
+						write (l,string'("Dlen ;" & integer'image(dlen) & ";Finalize of Proc n°; " & image(MyRank) & "; started at ; " & time'image(now)));
+						report l.all;
+						writeline (f, l) ; 
+					end if;	
+					 
+					if ct=0 then
+						RunState<=start;	
+						write (l,string'("Dlen ;" & integer'image(dlen) & ";Finalize of Proc n°; " & image(MyRank) & "; ended at ; " & time'image(now)));
+						report l.all;
+						writeline (f, l) ;
+						file_close(f);	
+					end if;	  
+		
 			when st_timeout =>
 			  
@@ -397,54 +466,21 @@
 					PE_Ram_enb<=sram.enb;
 					
-		 when Initcompleted =>
-			      
-					PE_Ram_ena<=Lib_Init;
-					PE_Ram_we<='1';
-					PE_Ram_enb<='1';
-					
-			when GetRank1 =>
+		 					
+			when GetRank =>
 
 					PE_Ram_we<=sram.we;
 					PE_Ram_ena<=sram.ena;
 					PE_Ram_enb<=sram.enb;
-			when GetRank2 =>
-					PE_Ram_ena<='0';
-					   --lecture effective du rang
-					PE_Ram_enb<='1';
-					--MyRank<=PE_ram_do(3 downto 0);
-			when GetRank3 =>
-					PE_Ram_ena<='0';
-					   --lecture effective du rang
-					PE_Ram_enb<='1';
-					--MyRank<=PE_ram_do(3 downto 0);		
-		 when writeptr =>
-					PE_Ram_we  <='1';   --écriture dans la RAM
-					PE_Ram_ena <='1';
-					
-					PE_Ram_enb <='0';
-			--		dcount<=dcount+1;
-					
-					--PE_Instr_En<='0';
-		when InstrCopy =>  --instruction copy
-				   PE_Ram_we<='0';
-					PE_Ram_ena<='0';
-					PE_Ram_enb<='0';
-
-		
-		when putdata =>   --positionnement du mot de longueur des données
-				--dcount<=0;
-				srcadr0<=X"00";
-				srcadr1<=X"01";
-				destadr0<=X"00";
-				destadr1<=X"02";
-				   PE_Ram_we<='0';
-					PE_Ram_ena<='0';
-				
-					PE_Ram_enb<='1';
-				
-			when putdata2 =>
---					PE_Ram_we  <='1';   --écriture dans la RAM
---					PE_Ram_ena <='1';
---					PE_Ram_enb <='0';
+			when WinCreate =>
+					
+					PE_Ram_we<=sram.we;
+					PE_Ram_ena<=sram.ena;
+					PE_Ram_enb<=sram.enb;
+
+		
+			  --positionnement du mot de longueur des données
+				
+				
+			when putdata =>
 					srcadr0<=X"00";
 					srcadr1<=X"01";
@@ -454,30 +490,16 @@
 					PE_Ram_ena<=sram.ena;
 					PE_Ram_enb<=sram.enb;
-					
-			when putcompleted =>			
-					PE_Ram_we  <='1';
-					PE_Ram_ena <='1';
-					  -- lecture du résultat
-					PE_Ram_enb  <='1';
-					--PE_Instr_En<='1';
+		
 			when getdata =>
 				PE_Ram_we<=sram.we;
 				PE_Ram_ena<=sram.ena;
 				PE_Ram_enb<=sram.enb;
-
-				
-			when getdata2 =>
-				   PE_Ram_we  <='1';   --écriture dans la RAM
-					PE_Ram_ena <='1';
-					
-					PE_Ram_enb <='0';
-				
-			when getcompleted =>				
-					PE_Ram_we  <='1';
-					PE_Ram_ena <='1';
-
-					PE_Ram_enb  <='1';
-				
-			when terminate =>
+				
+			when Wincompleted =>				
+					PE_Ram_we<=sram.we;
+					PE_Ram_ena<=sram.ena;
+					PE_Ram_enb<=sram.enb;
+				
+			when finalize =>
 			
 				   PE_Ram_we<='0';
Index: PROJECT_CORE_MPI/CORE_MPI/BRANCHES/v0.01/Packet_type.vhd
===================================================================
--- PROJECT_CORE_MPI/CORE_MPI/BRANCHES/v0.01/Packet_type.vhd	(revision 37)
+++ PROJECT_CORE_MPI/CORE_MPI/BRANCHES/v0.01/Packet_type.vhd	(revision 39)
@@ -49,5 +49,5 @@
 SUBType MPI_COMM is  natural range 0 to 2**ADRLEN1-1 ; --pointeur sur la structure du communicateur
 subType Mpi_AInt is natural range 0 to 2**ADRLEN1-1 ;
-
+--subType Mpi_win is natural range 0 to 2**ADRLEN1-1 ;
 Type MPI_COMM_struc is record
    id : natural range 0 to 3; -- id du communicateur
Index: PROJECT_CORE_MPI/CORE_MPI/BRANCHES/v0.01/iseconfig/MultiMPITest.xreport
===================================================================
--- PROJECT_CORE_MPI/CORE_MPI/BRANCHES/v0.01/iseconfig/MultiMPITest.xreport	(revision 37)
+++ PROJECT_CORE_MPI/CORE_MPI/BRANCHES/v0.01/iseconfig/MultiMPITest.xreport	(revision 39)
@@ -2,5 +2,5 @@
 <report-views version="2.0" >
  <header>
-  <DateModified>2012-12-03T14:51:11</DateModified>
+  <DateModified>2012-12-05T03:48:30</DateModified>
   <ModuleName>MultiMPITest</ModuleName>
   <SummaryTimeStamp>2012-11-05T16:48:15</SummaryTimeStamp>
